 /*******************************************************************************
*
*	TITLE:		offense.c 
*
*	VERSION:	0.1                           
*
*	DATE:		02-12-2007
*
*	AUTHOR:		Team 1511
*
*	DESCRIPTION:	This file contains functions to drive the various autonomous modes of the robot.
********************************************************************************
*
*	CHANGE LOG:
*
*	DATE         REV  DESCRIPTION
*	-----------  ---  ----------------------------------------------------------
* 	12-Feb-2007  0.1  Initial revision.
*
*******************************************************************************/

#include <stdio.h>
#include "ifi_aliases.h"
#include "ifi_default.h"
#include "ifi_utilities.h"
#include "user_routines.h"
#include "serial_ports.h"
#include "encoder.h"
#include "motion.h"
#include "tracking.h"
#include "defense.h"
#include "camera.h"
#include "offense.h"
#include "control.h"


// this varables are used for this class only
int Distance_counter=0;
int Encoder_left=0;
int Encoder_right=0;
int Encoder_Aver=0;
char Camera_lock_state=0;
int Step_Auto=0;
int ARMS_Check=0;
int Encoder_Reset_default=0;
int Camera_YAngle_Max= 90;
float degree_90_inch = 16.493361;


extern int Angle_XTracking_info, Angle_YTracking_info;

/*
*	wrote by jim bossert
*	this function chose which subseletion2 function to call
*	based on mode value passed as Automodes to declide what
*	stragry to used in offensive auto mode
*	NOTE: any selection made are offical are passed to secondary 
*	seletion function below this function titled Subseletion2
*	NOTE: any selection that used for short testing and not offical
*	are based this subseletion1
*/
void SubSeletion1 (int Automodes)
{
	//needed a function to set turrget to neutuel by default

	if (Automodes == 40)
	{
		subseletion2_40 ();
	}
	else if (Automodes == 41)
	{
		subseletion2_41 ();
	}
	else if (Automodes == 42)
	{
		subseletion2_42 ();
	}
	else if (Automodes == 43)
	{
		subseletion2_43 ();
	}
	else if (Automodes == 44)
	{
		subseletion2_44 ();
	}
	else if (Automodes == 45)
	{
		subseletion2_45 ();
	}
	else if (Automodes == 46)
	{
		subseletion2_46 ();
	}
	else if (Automodes == 47)
	{
		subseletion2_47 ();
	}
	else if (Automodes == 48)
	{
		subseletion2_48 ();
	}
	else if (Automodes == 49)
	{
		subseletion2_49 ();
	}
  else if (Automodes == 50)
  {
    subseletion2_50 ();
  }
  else if (Automodes == 51)
  {
    subseletion2_51 ();
  }


//unoffical seletions that is use for testing purposes only
  else if (Automodes == 52)
  {
    Straight_line1();
  }
  else if (Automodes == 53)
  {
    StraightShort_line();
  }
  else if (Automodes == 54)
  {
    BackOut_line();
  }
  else if (Automodes == 55)
  {
    if (Step_Auto==0)
    {
      First_Camera_Tracking_mode();
    }
    else if (Step_Auto==1)
    {
      Drive_Tracking();
    }
  }
  else if (Automodes == 56)
  {
    if (ARMS_Check==0)
    {
      Arm_Auto_Init(ARM_CMD_LOW);
      ARMS_Check++;
      printf("Doing the arm command \n\r");
    }
    else if (ARMS_Check==1 &&Arm_Auto_Process()!= 0)
    {
      ARMS_Check++;
      printf("IT is finished \n\r");
    }
    else
    Arm_Auto_Init(ARM_CMD_LOW);


    printf("Doing the arm thing loop \r\n");
  }
  else if (Automodes == 57)
  {
    if (ARMS_Check==0)
    {
      Arm_Auto_Init(ARM_CMD_PICKUP);
      ARMS_Check++;
    }
    else if (ARMS_Check==1 &&Arm_Auto_Process()!= 0)
    {
      ARMS_Check++;
    }
  }
  else if (Automodes == 58)
  {
    if (ARMS_Check==0)
    {
      printf("Init\r\n");
      Arm_Auto_Init(ARM_CMD_MID);
      ARMS_Check++;
    }
    else if (ARMS_Check==1 &&Arm_Auto_Process()!= 0)
    {
      printf("Done\r\n");
      ARMS_Check++;
    }
    else printf("Working\r\n");
  }
  else if (Automodes == 59)
  {
    if (ARMS_Check==0)
    {
      Arm_Auto_Init(ARM_CMD_HI);
      ARMS_Check++;
    }
    else if (ARMS_Check==1 &&Arm_Auto_Process()!= 0)
    {
      ARMS_Check++;
    }
  }
  else if (Automodes == 60)
  {
    if (ARMS_Check==0)
    {
      Open_Manip();
      ARMS_Check++;
    }
    else if (ARMS_Check==1 &&Get_Manip_State!= 0)
    {
      ARMS_Check++;
      Stop_Manip();
      printf("It worked!\r\n");
    }
  }
  else if (Automodes == 61)
  {
    int answer1 =0;
    int answer2 =0;
    answer1=Get_XAngle_Tracking_info();
    answer2=Get_YAngle_Tracking_info();
//	this printf are needed for debug x and y angle in total angle purposes
//    printf("X Angle %d \r\n", answer1);
//    printf("Y Angle %d \r\n", answer2);
  }
	else if (Automodes == 62)
	{
	//
	Auto_Drive(0.95, 1, 200);
	}
	else if (Automodes == 63)
	{
	//
	Auto_Drive(1, 0.95, 200);
	}
	else if (Automodes == 64)
	{
	//
	Auto_Drive(0.95, 0.95, 200);
	}
	else if (Automodes == 65)
	{
	//
	Auto_Drive(5, 1, 200);
	}
	else if (Automodes == 66)
	{
	//
	Auto_Drive(5, 1, 200);
	}
	else if (Automodes == 67)
	{
	//
	Auto_Drive(1, 1, 200);
	}
  else if (Automodes == 68)
  {
    Spin_Tracking ();
  }
  else if (Automodes ==  69)
  {
    clockwise_turn (190);
  }
  else if (Automodes == 69)
  {
    counter_clockwise_turn (190);
  }
  else if (Automodes == 70)
  {
    Turn_counter_clockwise();
  }
  
	else
  {
    Turn_clockwise();
  }

  
	return;

}


/*
*	wrote by jim bossert
*	this group of functions of subseletion2 declide where the robot are according
*	agroitm that each stragrty followed into that in turn to call indualival 
*	funtions to do change spectific values
*	if can found that it finished a task, it upgrade submodes1 to not do same 
*	functions in a row instead moving on
*	NOTE: any seletions made into this list is offical supported and working
*/
//this function is for a start postion and score on the right side
//of the rack at low level
void subseletion2_40 (void)
{
	if (Step_Auto==0)
	{
		if (ARMS_Check==0)
    	{
      	Arm_Auto_Init(ARM_CMD_PICKUP);
      	ARMS_Check++;
    	}
		else if (ARMS_Check==1 ||Arm_Auto_Process()!= 0)
    	{
      	Step_Auto++;
    	}
	}
	else if (Step_Auto==1)
	{
		Straight_line1();
	}
	else if (Step_Auto==2)
	{
		pwm_left_drive=127;
		pwm_right_drive=127;
		Step_Auto++;
	}
	else if (Step_Auto==3)
	{
		First_Camera_Tracking_mode();
	}
	else if (Step_Auto==4)
	{
		Drive_Tracking();
	}
	else if (Step_Auto==5)
	{
		if (ARMS_Check==0)
    	{
      	Arm_Auto_Init(ARM_CMD_LOW);
      	ARMS_Check++;
    	}
    	else if (ARMS_Check==1 ||Arm_Auto_Process()!= 0)
    	{
      	Step_Auto++;
    	}
	}
	else if (Step_Auto==6)
	{
		StraightShort_line();
	}
	else if (Step_Auto==7)
	{
		if (ARMS_Check==0)
    	{
      	Open_Manip;
      	ARMS_Check++;
    	}
    	else if (ARMS_Check==1 ||Get_Manip_State!= 0)
    	{
      	Step_Auto++;
      	Stop_Manip();
    	}
	}
	else if (Step_Auto==8)
	{
		StraightShort_line();
	}
	else if (Step_Auto==9)
	{
		if (ARMS_Check==0)
    	{
      	Arm_Auto_Init(ARM_CMD_LOW);
      	ARMS_Check++;
    	}
    	else if (ARMS_Check==1 ||Arm_Auto_Process()!= 0)
    	{
      	Step_Auto++;
    	}
	}
	else
	{
		pwm_left_drive=127;
		pwm_right_drive=127;
	}


	return;
}
//this function is for a corner start postion and score on the right side
//of the rack at middle level
void subseletion2_41 ()
{
	if (Step_Auto==0)
	{
		if (ARMS_Check==0)
    	{
      	Arm_Auto_Init(ARM_CMD_PICKUP);
      	ARMS_Check++;
    	}
		else if (ARMS_Check==1 ||Arm_Auto_Process()!= 0)
    	{
      	Step_Auto++;
    	}
	}
	else if (Step_Auto==1)
	{
		Straight_line1();
	}
	else if (Step_Auto==2)
	{
		pwm_left_drive=127;
		pwm_right_drive=127;
		Step_Auto++;
	}
	else if (Step_Auto==3)
	{
		First_Camera_Tracking_mode();
	}
	else if (Step_Auto==4)
	{
		Drive_Tracking();
	}
	else if (Step_Auto==5)
	{
		if (ARMS_Check==0)
    	{
      	Arm_Auto_Init(ARM_CMD_MID);
      	ARMS_Check++;
    	}
    	else if (ARMS_Check==1 ||Arm_Auto_Process()!= 0)
    	{
      	Step_Auto++;
    	}
	}
	else if (Step_Auto==6)
	{
		StraightShort_line();
	}
	else if (Step_Auto==7)
	{
		if (ARMS_Check==0)
    	{
      	Open_Manip;
      	ARMS_Check++;
    	}
    	else if (ARMS_Check==1 ||Get_Manip_State!= 0)
    	{
      	Step_Auto++;
      	Stop_Manip();
    	}
	}
	else if (Step_Auto==8)
	{
		StraightShort_line();
	}
	else if (Step_Auto==9)
	{
		if (ARMS_Check==0)
    	{
      	Arm_Auto_Init(ARM_CMD_LOW);
      	ARMS_Check++;
    	}
    	else if (ARMS_Check==1 ||Arm_Auto_Process()!= 0)
    	{
      	Step_Auto++;
    	}
	}
	else
	{
		pwm_left_drive=127;
		pwm_right_drive=127;
	}
	return;
}
//this function is for a corner start postion and score on the right side
//of the rack at high level
void subseletion2_42 ()
{
	if (Step_Auto==0)
	{
		if (ARMS_Check==0)
    	{
      	Arm_Auto_Init(ARM_CMD_PICKUP);
      	ARMS_Check++;
    	}
		else if (ARMS_Check==1 ||Arm_Auto_Process()!= 0)
    	{
      	Step_Auto++;
    	}
	}
	else if (Step_Auto==1)
	{
		Straight_line1();
	}
	else if (Step_Auto==2)
	{
		pwm_left_drive=127;
		pwm_right_drive=127;
		Step_Auto++;
	}
	else if (Step_Auto==3)
	{
		First_Camera_Tracking_mode();
	}
	else if (Step_Auto==4)
	{
		Drive_Tracking();
	}
	else if (Step_Auto==5)
	{
		if (ARMS_Check==0)
    	{
      	Arm_Auto_Init(ARM_CMD_HI);
      	ARMS_Check++;
    	}
    	else if (ARMS_Check==1 ||Arm_Auto_Process()!= 0)
    	{
      	Step_Auto++;
    	}
	}
	else if (Step_Auto==6)
	{
		StraightShort_line();
	}
	else if (Step_Auto==7)
	{
		if (ARMS_Check==0)
    	{
      	Open_Manip;
      	ARMS_Check++;
    	}
    	else if (ARMS_Check==1 ||Get_Manip_State!= 0)
    	{
      	Step_Auto++;
      	Stop_Manip();
    	}
	}
	else if (Step_Auto==8)
	{
		StraightShort_line();
	}
	else if (Step_Auto==9)
	{
		if (ARMS_Check==0)
    	{
      	Arm_Auto_Init(ARM_CMD_HI);
      	ARMS_Check++;
    	}
    	else if (ARMS_Check==1 ||Arm_Auto_Process()!= 0)
    	{
      	Step_Auto++;
    	}
	}
	else
	{
		pwm_left_drive=127;
		pwm_right_drive=127;
	}
	return;
}
// this function is for middle start postion and score on middle side of the 
//rack at low level
void subseletion2_43 ()
{
	if (Step_Auto==0)
	{
		if (ARMS_Check==0)
    	{
      	Arm_Auto_Init(ARM_CMD_PICKUP);
      	ARMS_Check++;
    	}
		else if (ARMS_Check==1 ||Arm_Auto_Process()!= 0)
    	{
      	Step_Auto++;
    	}
	}
	else if (Step_Auto==1)
	{
		Straight_line2();
	}
	else if (Step_Auto==2)
	{
		pwm_left_drive=127;
		pwm_right_drive=127;
		Step_Auto++;
	}
	else if (Step_Auto==3)
	{
		First_Camera_Tracking_mode();
	}
	else if (Step_Auto==4)
	{
		Drive_Tracking();
	}
	else if (Step_Auto==5)
	{
		if (ARMS_Check==0)
    	{
      	Arm_Auto_Init(ARM_CMD_LOW);
      	ARMS_Check++;
    	}
    	else if (ARMS_Check==1 ||Arm_Auto_Process()!= 0)
    	{
      	Step_Auto++;
    	}
	}
	else if (Step_Auto==6)
	{
		StraightShort_line();
	}
	else if (Step_Auto==7)
	{
		if (ARMS_Check==0)
    	{
      	Open_Manip;
      	ARMS_Check++;
    	}
    	else if (ARMS_Check==1 ||Get_Manip_State!= 0)
    	{
      	Step_Auto++;
      	Stop_Manip();
    	}
	}
	else if (Step_Auto==8)
	{
		StraightShort_line();
	}
	else if (Step_Auto==9)
	{
		if (ARMS_Check==0)
    	{
      	Arm_Auto_Init(ARM_CMD_LOW);
      	ARMS_Check++;
    	}
    	else if (ARMS_Check==1 ||Arm_Auto_Process()!= 0)
    	{
      	Step_Auto++;
    	}
	}
	else
	{
		pwm_left_drive=127;
		pwm_right_drive=127;
	}


	return;
}
// this function is for middle start postion and score on middle side of the 
//rack at middle level
void subseletion2_44 ()
{
	if (Step_Auto==0)
	{
		if (ARMS_Check==0)
    	{
      	Arm_Auto_Init(ARM_CMD_PICKUP);
      	ARMS_Check++;
    	}
		else if (ARMS_Check==1 ||Arm_Auto_Process()!= 0)
    	{
      	Step_Auto++;
    	}
	}
	else if (Step_Auto==1)
	{
		Straight_line1();
	}
	else if (Step_Auto==2)
	{
		pwm_left_drive=127;
		pwm_right_drive=127;
		Step_Auto++;
	}
	else if (Step_Auto==3)
	{
		First_Camera_Tracking_mode();
	}
	else if (Step_Auto==4)
	{
		Drive_Tracking();
	}
	else if (Step_Auto==5)
	{
		if (ARMS_Check==0)
    	{
      	Arm_Auto_Init(ARM_CMD_MID);
      	ARMS_Check++;
    	}
    	else if (ARMS_Check==1 ||Arm_Auto_Process()!= 0)
    	{
      	Step_Auto++;
    	}
	}
	else if (Step_Auto==6)
	{
		StraightShort_line();
	}
	else if (Step_Auto==7)
	{
		if (ARMS_Check==0)
    	{
      	Open_Manip;
      	ARMS_Check++;
    	}
    	else if (ARMS_Check==1 ||Get_Manip_State!= 0)
    	{
      	Step_Auto++;
      	Stop_Manip();
    	}
	}
	else if (Step_Auto==8)
	{
		StraightShort_line();
	}
	else if (Step_Auto==9)
	{
		if (ARMS_Check==0)
    	{
      	Arm_Auto_Init(ARM_CMD_LOW);
      	ARMS_Check++;
    	}
    	else if (ARMS_Check==1 ||Arm_Auto_Process()!= 0)
    	{
      	Step_Auto++;
    	}
	}
	else
	{
		pwm_left_drive=127;
		pwm_right_drive=127;
	}


	return;
}
// this function is for middle start postion and score on middle side of the 
//rack at high level
void subseletion2_45 ()
{
	if (Step_Auto==0)
	{
		if (ARMS_Check==0)
    	{
      	Arm_Auto_Init(ARM_CMD_PICKUP);
      	ARMS_Check++;
    	}
		else if (ARMS_Check==1 ||Arm_Auto_Process()!= 0)
    	{
      	Step_Auto++;
    	}
	}
	else if (Step_Auto==1)
	{
		Straight_line1();
	}
	else if (Step_Auto==2)
	{
		pwm_left_drive=127;
		pwm_right_drive=127;
		Step_Auto++;
	}
	else if (Step_Auto==3)
	{
		First_Camera_Tracking_mode();
	}
	else if (Step_Auto==4)
	{
		Drive_Tracking();
	}
	else if (Step_Auto==5)
	{
		if (ARMS_Check==0)
    	{
      	Arm_Auto_Init(ARM_CMD_HI);
      	ARMS_Check++;
    	}
    	else if (ARMS_Check==1 ||Arm_Auto_Process()!= 0)
    	{
      	Step_Auto++;
    	}
	}
	else if (Step_Auto==6)
	{
		StraightShort_line();
	}
	else if (Step_Auto==7)
	{
		if (ARMS_Check==0)
    	{
      	Open_Manip;
      	ARMS_Check++;
    	}
    	else if (ARMS_Check==1 ||Get_Manip_State!= 0)
    	{
      	Step_Auto++;
      	Stop_Manip();
    	}
	}
	else if (Step_Auto==8)
	{
		StraightShort_line();
	}
	else if (Step_Auto==9)
	{
		if (ARMS_Check==0)
    	{
      	Arm_Auto_Init(ARM_CMD_LOW);
      	ARMS_Check++;
    	}
    	else if (ARMS_Check==1 ||Arm_Auto_Process()!= 0)
    	{
      	Step_Auto++;
    	}
	}
	else
	{
		pwm_left_drive=127;
		pwm_right_drive=127;
	}


	return;
}
// this function is for middle start postion and score on middle side of the 
//rack at low level
void subseletion2_46 ()
{
	
	return;
}
//this function is for left corner start postion and score on the right side
//of the rack at high level
void subseletion2_47 ()
{
	
	return;
}
//this function is for left corner start postion and score on the right side
//of the rack at middle level
void subseletion2_48 ()
{
	
	return;
}
//this function is for left corner start postion and score on the right side
//of the rack at low level
void subseletion2_49 ()
{
	return;
}
void subseletion2_50()
{
  return;
}
void subseletion2_51()
{
  
  return;
}


/*
*	wrote by jim bossert
*
*	this group of functions are using encoder to advances robot to a fixed 
*	distance straight ahead using Rajvee's function in encoder.c and .h and little
*	based on motion.c and motion.h
*
*/
/*
*	wrote by jim bossert
*	a function to move the robot 11 ft or so foward
*/
void Straight_line1()
{
	int Distance_encoder=11;	

	Encoder_left = Get_Left_Encoder_Count()/TICKS_PER_FOOT;
	Encoder_right = Get_Right_Encoder_Count()/TICKS_PER_FOOT;
	if (Encoder_left != 0 || Encoder_right != 0)
	{
		Encoder_Aver= (Encoder_left+Encoder_right)/2;
	}
	else
	Encoder_Aver=0;

	
	if (Encoder_Aver<Distance_encoder)
	{
		Auto_Drive ( 1, 1, 160);
	}
	else if (Encoder_Aver>=Distance_encoder)
	{
		pwm_left_drive=127;
		pwm_right_drive=127;
		Step_Auto++;
	}
	return;
}
/*
* wrote by jim bossert
* a function to move the robot 7 ft or so forward
* only used in middle start postion that follow the green light to middle col of rack
*
*/
void Straight_line2()
{
	int Distance_encoder=7;	

	Encoder_left = Get_Left_Encoder_Count()/TICKS_PER_FOOT;
	Encoder_right = Get_Right_Encoder_Count()/TICKS_PER_FOOT;
	if (Encoder_left != 0 || Encoder_right != 0)
	{
		Encoder_Aver= (Encoder_left+Encoder_right)/2;
	}
	else
	Encoder_Aver=0;

	
	if (Encoder_Aver<Distance_encoder)
	{
		Auto_Drive ( 1, 1, 160);
	}
	else if (Encoder_Aver>=Distance_encoder)
	{
		pwm_left_drive=127;
		pwm_right_drive=127;
		Step_Auto++;
	}
	return;
}
/*
* wrote by jim bossert
* a function to move the robot 7 ft or so forward
* only used in corner start postion that follow the green light to middle side of rack
*
*/
void Straight_line3()
{
	int Distance_encoder=20;	

	Encoder_left = Get_Left_Encoder_Count()/TICKS_PER_FOOT;
	Encoder_right = Get_Right_Encoder_Count()/TICKS_PER_FOOT;
	if (Encoder_left != 0 || Encoder_right != 0)
	{
		Encoder_Aver= (Encoder_left+Encoder_right)/2;
	}
	else
	Encoder_Aver=0;

	
	if (Encoder_Aver<Distance_encoder)
	{
		Auto_Drive ( 1, 1, 160);
	}
	else if (Encoder_Aver>=Distance_encoder)
	{
		pwm_left_drive=127;
		pwm_right_drive=127;
		Step_Auto++;
	}
	return;
}
/*
*	wrote by jim bossert
*	used to move robot a short distance straight (used to avance the rack
*	when the camera no longer used
*/
void StraightShort_line()
{
	int Distance2_encoder=2;	

if (ARMS_Check==0)
  {
    Reset_Left_Encoder_Count();
    Reset_Right_Encoder_Count();
    ARMS_Check++;
  }

	Encoder_left = Get_Left_Encoder_Count()/TICKS_PER_FOOT;
	Encoder_right = Get_Right_Encoder_Count()/TICKS_PER_FOOT;
	if (Encoder_left != 0 || Encoder_right != 0)
	{
		Encoder_Aver= (Encoder_left+Encoder_right)/2;
	}

	else
	Encoder_Aver=0;

	
	if (Encoder_Aver<Distance2_encoder)
	{
		Auto_Drive ( 1, 1, 160);

	}
	else if (Encoder_Aver>=Distance2_encoder)
	{
		pwm_left_drive=127;
		pwm_right_drive=127;
		Step_Auto++;
	}

	return;
}
/*
*	wrote by jim bossert
*	used to move robot by spin to 90 degress counterclockwise
*
*/
void Turn_counter_clockwise()
{
		

if (ARMS_Check==0)
  {
    Reset_Left_Encoder_Count();
    Reset_Right_Encoder_Count();
    ARMS_Check++;
  }

	Encoder_left = Get_Left_Encoder_Count()/TICKS_PER_FOOT;
	Encoder_right = Get_Right_Encoder_Count()/TICKS_PER_FOOT;
	if (Encoder_left != 0 || Encoder_right != 0)
	{
		Encoder_Aver= (Encoder_left+Encoder_right)/2;
	}

	else
	Encoder_Aver=0;

	
	if (Encoder_Aver<degree_90_inch)
	{
		counter_clockwise_turn (190);

	}
	else if (Encoder_Aver>=degree_90_inch)
	{
		pwm_left_drive=127;
		pwm_right_drive=127;
		Step_Auto++;
	}

	return;
}
/*
*	wrote by jim bossert
*	used to move robot by spin to 90 degress counterclockwise
*
*/
void Turn_clockwise()
{
		

if (ARMS_Check==0)
  {
    Reset_Left_Encoder_Count();
    Reset_Right_Encoder_Count();
    ARMS_Check++;
  }

	Encoder_left = Get_Left_Encoder_Count()/TICKS_PER_FOOT;
	Encoder_right = Get_Right_Encoder_Count()/TICKS_PER_FOOT;
	if (Encoder_left != 0 || Encoder_right != 0)
	{
		Encoder_Aver= (Encoder_left+Encoder_right)/2;
	}

	else
	Encoder_Aver=0;

	
	if (Encoder_Aver<degree_90_inch)
	{
		clockwise_turn (190);

	}
	else if (Encoder_Aver>=degree_90_inch)
	{
		pwm_left_drive=127;
		pwm_right_drive=127;
		Step_Auto++;
	}

	return;
}
/*
*	wrote by jim bossert
*
*	used this function to move the robot 2 ft back
*	in order backout the rack
*/
void BackOut_line()
{
	int Distance3_encoder=2;	
  if (Encoder_Reset_default==0)
  {
    Reset_Left_Encoder_Count();
    Reset_Right_Encoder_Count();
    Encoder_Reset_default++;
  }

	Encoder_left = Get_Left_Encoder_Count()/TICKS_PER_FOOT;
	Encoder_right = Get_Right_Encoder_Count()/TICKS_PER_FOOT;
	if (Encoder_left != 0 || Encoder_right != 0)
	{
		Encoder_Aver= (Encoder_left+Encoder_right)/2;
	}
	else
  {
	Encoder_Aver=0;
  }

	
	if (Encoder_Aver<Distance3_encoder)
	{
			Auto_Drive ( 1, 1, 95);
    
	}
	else if (Encoder_Aver>=Distance3_encoder)
	{
		pwm_left_drive = 127;
    pwm_right_drive = 127;
		Step_Auto++;
	}
  return;
}
/*
*	Wrote by Jim bossert
*	this function start the process of the camera tracking the green light before
*	jump to any steps that required this working right
*
*
*/
void First_Camera_Tracking_mode(void)
{
	
	Camera_lock_state=Get_Tracking_State();
	
	if (0!=Camera_lock_state)
		{
			Step_Auto++;
		}
	else
	{
	
	}

	return;
}
/*
*	Wrote by Jim bossert
*	this function start the process of the camera tracking the green light and tracking
*	train drive toward it before it hit specific Y-axis
*
*
*/
void Drive_Tracking()
{
	int Xangle_info;
	
	
	Camera_lock_state=Get_Tracking_State();
	Xangle_info=Get_XAngle_Camera();
	
	if (0==Camera_lock_state)
		{
			Step_Auto--;
      pwm_left_drive=127;
      pwm_right_drive=127;
		}
	
	else if (Xangle_info<-5||Xangle_info>=-15)
	{
Auto_Drive ( 1, 0.95, 220);

	}
	else if (Xangle_info<-15||Xangle_info>=-20)
	{
	Auto_Drive ( 1, 0.90, 220);

	}
	else if (Xangle_info<-20||Xangle_info>=-25)
	{
	Auto_Drive ( 1, 0.85, 220);

	}
	else if (Xangle_info<-25||Xangle_info>=-35)
	{
	Auto_Drive ( 1, 0.80, 220);

	}
	else if (Xangle_info<-35||Xangle_info>=-90)
	{
	Auto_Drive ( 1, 0.75, 220);

	}
	else if (Xangle_info<5||Xangle_info>=15)
	{
	Auto_Drive ( 0.95, 1, 220);

	}
	else if (Xangle_info<15||Xangle_info>=20)
	{
	Auto_Drive ( 0.90, 1, 220);

	}
	else if (Xangle_info<20||Xangle_info>=25)
	{
	Auto_Drive ( 0.85, 1, 220);

	}
	else if (Xangle_info<25||Xangle_info>=35)
	{
	Auto_Drive ( 0.80, 1, 220);

	}
	else if (Xangle_info<35||Xangle_info>=90)
	{
	Auto_Drive ( 0.75, 1, 220);

	}
	else if (Xangle_info<5||Xangle_info>=-5)
	{
	Auto_Drive ( 1, 1, 220);
	}
	else
	{
	pwm_left_drive=127;
	pwm_right_drive=127;
	}
	
  if (Get_YAngle_Camera()>= Camera_YAngle_Max)
    {
      pwm_left_drive=127;
      pwm_right_drive=127;
      Step_Auto++;
    }

	return;
}
/*
*   wrote by jim bossert 
*   the function's purpose is that use camera tracking info to help the 
*   robot to align toward the green light 
*   it is only helpful if the green lights are cross-like and the robot set up at
*   the corner postion
*
*/
void Spin_Tracking ()
{
    int Xangle_info;
	
	
	Camera_lock_state=Get_Tracking_State();
	Xangle_info=Get_XAngle_Camera();
	
	if (0==Camera_lock_state)
		{
			Step_Auto--;
      pwm_left_drive=127;
      pwm_right_drive=127;
		}
  else if (Xangle_info >5)
  {
    clockwise_turn (220);
  }
  else if (Xangle_info <-5)
  {
    counter_clockwise_turn (220);
  }
  else if (Xangle_info >=-5||Xangle_info<=5)
  {
    Step_Auto++;
  }

}
